
#include <Log.h>

#include "dedup.h"

int main(int argc, const char** argv) {
	Log::init();
	Log::setConsoleLogLevel(Log::Level::trace);
	Log::addLogfile("log.txt", Log::Level::trace);
#if __unix__
	Log::setColoredOutput(true);
#endif
	Log::info << "Hello, World!";

	if(argc < 2) {
		Log::fatal << "Usage: " << argv[0] << " <path> [path2] [...]";
		return -1;
	}

	Dedup dedup;

	for(int i = 1; i < argc; ++i) {
		dedup.addSearchFolder(argv[i]);
	}

	dedup.start();

	Log::stop();
	return 0;
}
